<template>
  <v-container fill-height fluid grid-list-xl>
    <v-layout wrap>
      <TestBuilder v-model="test" class="my-5" />
      <v-btn @click="saveTest" color="success">Сохранить тест</v-btn>
    </v-layout>
  </v-container>
</template>
<script>
import MCard from "@/components/material/Card";
import { VTextField, VSelect } from "vuetify/lib";
import { mapState } from "vuex";

export default {
  components: {
    "meterial-card": MCard
  },
  data() {
    return {
      test: {
        questions: []
      },
      tab: null,
      formData: {},
      tabs: 0,
      list: {
        0: false,
        1: false,
        2: false
      }
    };
  },
  computed: {
    ...mapState("user", ["classes"]),
    ...mapState("user", {
      userData: state => state
    }),
    questionsScheme() {
      return [];
    }
  },
  methods: {
    async saveTest() {
      const res = await this.$store.dispatch("createTest", {
        ...this.test.baseInfo,
        questions: this.test.questions.map((item) => {
          delete item.id;
          return item;
        }),
        author: { name: this.userData.name, _id: this.userData._id }
      });

      if (!res.err) {
        this.$store.dispatch('setMessageText', {
          text: 'Вы успешно создали тест!',
          type: 'success',
        })
         setTimeout(() => this.$router.push('/test/list'), 1500);
      } else {
        this.$store.dispatch('setMessageText', {
          text: res.err,
          type: 'error',
        })
      }

     
    },
    changeHandler(obj) {
      const reducer = (acc, value) => {
        const fieldName = value[0];
        const fieldValue = value[1];

        return Object.assign(acc, { [fieldName]: fieldValue });
      };

      let formDataCopy = { ...this.formData };
      let data = Object.entries(obj).reduce(reducer, {});

      let formData = Object.assign(formDataCopy, data);

      this.formData = formData;
    }
  }
};
</script>
<style lang="scss">
.wrapper {
  width: 100%;
}
.card-tabs {
  width: 100%;
}
.v-card.green .v-tabs-bar {
  background: linear-gradient(60deg, #66bb6a, #43a047) !important;
}
</style>
